#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

public Plugin:myinfo = 
{
	name = "Obstacle_Kill",
	author = "wS / Schmidt",
	description = "Bonus for killing through the obstacle",
	version = "1.2",
	url = "http://world-source.ru/forum/118"
};

new BeamIndex;
new Handle:ok_gift, Handle:ok_gift_value, Handle:ok_entkill, Handle:ok_showdist;

public OnPluginStart()
{
	LoadTranslations("Obstacle_Kill.phrases");

	ok_gift			= CreateConVar("ok_gift",		"1",	"0 - do nothing, 1 - give hp, 2 - give cash", FCVAR_NOTIFY, true, 0.0, true, 2.0);
	ok_gift_value	= CreateConVar("ok_gift_value",	"50",	"value (depends on the ok_gift)", FCVAR_NOTIFY, true, 1.0);
	ok_entkill		= CreateConVar("ok_entkill",	"1",	"1 - remove obstacles, 0 = no", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	ok_showdist		= CreateConVar("ok_showdist",	"1",	"1 - show the distance from the obstacle to the victim, 0 = no", FCVAR_NOTIFY, true, 0.0, true, 1.0);

	HookEvent("player_death", player_death);
	CreateConVar("Obstacle_Kill", "1.2", "Obstacle_Kill version [ Plugin by World-Source.Ru ]", FCVAR_NOTIFY);
}

public OnMapStart()
{
	BeamIndex = PrecacheModel("materials/sprites/laser.vmt", true);
}

public player_death(Handle:event, const String:name[], bool:dontBroadcast)
{
	new killer = GetClientOfUserId(GetEventInt(event, "attacker"));
	if (killer < 1 || IsFakeClient(killer)) return;
	new client = GetClientOfUserId(GetEventInt(event, "userid")), killer_team = GetClientTeam(killer);
	if (killer_team != GetClientTeam(client))
	{
		decl String:weapon[15];
		GetEventString(event, "weapon", weapon, 15);
		if (!StrEqual(weapon, "hegrenade") && !StrEqual(weapon, "knife"))
		{
			decl Float:client_origin[3], Float:killer_origin[3], Float:x_origin[3];
			GetClientAbsOrigin(client, client_origin);
			GetClientEyePosition(killer, killer_origin); GetClientEyeAngles(killer, x_origin);
			TR_TraceRayFilter(killer_origin, x_origin, MASK_SOLID, RayType_Infinite, wS_TraceFilter, killer);
			new index = TR_GetEntityIndex();
			if (index < 0 || index == client) return;
			decl Float:end_origin[3]; TR_GetEndPosition(end_origin);
			if (GetVectorDistance(killer_origin, end_origin) < GetVectorDistance(killer_origin, client_origin))
			{
				decl String:killer_name[32], String:client_name[32], String:text[200];
				killer_name[0] = '\0'; client_name[0] = '\0';
				GetClientName(killer, killer_name, 32); GetClientName(client, client_name, 32);
				new author = killer_team == 2 ? killer : client;

				if (index > 0)
				{
					decl String:x_name[45]; x_name[0] = '\0';
					if (index <= MaxClients)
					{
						GetClientName(index, x_name, 45);
						Format(text, 200, "\x03%T", "kill_through_player", author, killer_name, client_name, x_name);
					}
					else
					{
						GetEntityClassname(index, x_name, 45);
						if (StrContains(x_name, "weapon_") == 0) return;
						Format(text, 200, "\x03%T", "kill_through_entity", author, killer_name, client_name, x_name);

						// удаление
						if (GetConVarBool(ok_entkill))
						{
							GetEntPropVector(index, Prop_Send, "m_vecOrigin", x_origin);
							AcceptEntityInput(index, "Kill");
							TE_SetupExplosion(x_origin, BeamIndex, 1.0, 0, TE_EXPLFLAG_NONE, 150, 3000);
							TE_SendToAll();
						}
					}
				}
				else Format(text, 200, "\x03%T", "kill_through_world_wall", author, killer_name, client_name);

				// расстояние
				if (GetConVarBool(ok_showdist))
				{
					Format(text, 200, "%s (%.1f m)", text, GetVectorDistance(end_origin, client_origin) / 39.3);
				}

				wS_TeamColorMsg(author, text);

				// подарок
				new wS_Gift = GetConVarInt(ok_gift);
				if (wS_Gift > 0)
				{
					new wS_Gift_Value = GetConVarInt(ok_gift_value);
					if (wS_Gift == 1)
					{
						SetEntProp(killer, Prop_Data, "m_iHealth", GetClientHealth(killer) + wS_Gift_Value);
						PrintHintText(killer, "%t", "hp_bonus_msg", wS_Gift_Value);
					}
					else
					{
						new cash = GetEntProp(killer, Prop_Send, "m_iAccount") + wS_Gift_Value;
						if (cash > 16000) cash = 16000;
						SetEntProp(killer, Prop_Send, "m_iAccount", cash);
						PrintHintText(killer, "%t", "cash_bonus_msg", wS_Gift_Value);
					}
				}
			}
		}
	}
}

public bool:wS_TraceFilter(ent, mask, any:killer) return ent != killer;

wS_TeamColorMsg(author, const String:msg[])
{
	new Handle:h = StartMessageAll("SayText2");
	if (h == INVALID_HANDLE) PrintToChatAll(msg);
	else
	{
		BfWriteByte(h, author);
		BfWriteByte(h, true);
		BfWriteString(h, msg);
		EndMessage();
	}
}